#include <stdio.h>

int main(int argc, char **argv) {
  char filename[] = "dumpfile.c";
  FILE *fp;
  int n;
  int i;
  int buf;
  int c;

  if (argc > 1) {
    sscanf(argv[1], "%u", &n);
  } else {
    n = 64;
  }

  fp = fopen(filename, "rb");
  if (fp == NULL) {
    printf("Cannot open file %s.\n", filename);
    return 1;
  }
  
  c = 0;
  for (i=0; i<n; i++) {
    buf = fgetc(fp);
    if (buf == EOF) {
      if ( ferror(fp) ) { printf("\nAn error occured.\n"); }
      break;
    }
    
    printf("%02X ", buf);
    if (++c == 16) { printf("\n"); c = 0; }
  }
  
  fclose(fp);
  
  return 0;
}
