#include <stdio.h>

/* SMFwb_`ÑTCY */
#define SIZE_OF_SMFHEADER 14

/* SMFwb_`Nێ\ */
typedef struct header {
  char chunktype[4];            /* `N^Cv: "MThd" */
  long unsigned int length;     /* f[^ */
  short unsigned int format;    /* tH[}bg^Cv */
  short unsigned int numtrack;  /* gbN */
  short unsigned int timebase;  /* ^Cx[X */
} SMFHEADER;

/* GfBAϊ֐ (4oCg̕p) */
long unsigned int convendian_uint32(long unsigned int obj) {
  long unsigned int ret = 0;
  int i;
  
  for (i=0; i<4; i++) {
    ret = ret << 8;
    ret |= ((unsigned char *)&obj)[i];
  }
  
  return ret;
}

/* GfBAϊ֐ (2oCg̕p) */
short unsigned int convendian_uint16(short unsigned int obj) {
  short unsigned int ret = 0;
  int i;
  
  for (i=0; i<2; i++) {
    ret = ret << 8;
    ret |= ((unsigned char *)&obj)[i];
  }
  
  return ret;
}

int main(void) {
  char filename[] = "sample.mid";  /* ǂݍރt@C */
  FILE *fp;       /* t@C|C^ */
  SMFHEADER hdr;  /* SMFwb_`Ni[邽߂̍\ */
  int i;          /* [vpϐ */
  
  /* t@CJ */
  if ( (fp = fopen(filename, "rb")) == NULL) {
    printf("Cannot open file %s.\n", filename);
    return 1;
  }
  
  /* wb_`NǂݍSMFHEADER\̂ɏ */
  fread(&hdr, SIZE_OF_SMFHEADER, 1, fp);
  
  /* t@C */
  fclose(fp);
  
  /* eõGfBAϊ */
  hdr.length = convendian_uint32(hdr.length);
  hdr.format = convendian_uint16(hdr.format);
  hdr.numtrack = convendian_uint16(hdr.numtrack);
  hdr.timebase = convendian_uint16(hdr.timebase);
  
  /* eo̒l\ */
  printf("Chunk type: %c%c%c%c\n", hdr.chunktype[0], hdr.chunktype[1],
                                   hdr.chunktype[2], hdr.chunktype[3]);
  printf("Data length: %u\n", hdr.length);
  printf("Format type: %u\n", hdr.format);
  printf("Number of tracks: %u\n", hdr.numtrack);
  printf("Time base: 0x%04X (%u)\n", hdr.timebase, hdr.timebase);
    
  return 0;
}
