#include <windows.h>
#include <mmsystem.h>

int main(void) {
  HMIDIOUT hMidiOut;
  unsigned int base;
  int i;

  int notes[] = {0x3c, 0x3e, 0x40, 0x41, 0x43, 0x45, 0x47, 0x48};
  int sleeptime = 1000;
  int velocity = 0x40;

  midiOutOpen(&hMidiOut, MIDI_MAPPER, 0, 0, 0);

  velocity = velocity << 16;
  for (i=0; i<8; i++) {
    base = (notes[i] << 8) + 0x90;
    midiOutShortMsg(hMidiOut, velocity + base);
    Sleep(sleeptime);
    midiOutShortMsg(hMidiOut, base);
  }

  midiOutReset(hMidiOut);
  midiOutClose(hMidiOut);

  return 0;
}
