#include <stdio.h>
#include <windows.h>
#include <mmsystem.h>

int main(void) {
  MIDIINCAPS inCaps;
  MMRESULT res;
  UINT num, devid;

  num = midiInGetNumDevs();
  printf("Number of input devices: %d\n", num);
  for (devid=0; devid<num; devid++) {
    res = midiInGetDevCaps(devid, &inCaps, sizeof(inCaps));
    if (res != MMSYSERR_NOERROR) { continue; }
    printf("ID=%d: %s\n", devid, inCaps.szPname);
  }

  return 0;
}
