#include <windows.h>
#include <mmsystem.h>

int main(void) {
  HMIDIOUT hMidiOut;

  midiOutOpen(&hMidiOut, MIDI_MAPPER, 0, 0, 0);

  midiOutShortMsg(hMidiOut, 0x007f3c90); /* m[gI: C4 (60=3C) */
  midiOutShortMsg(hMidiOut, 0x007f4090); /* m[gI: E4 (64=40) */
  midiOutShortMsg(hMidiOut, 0x007f4390); /* m[gI: G4 (67=43) */
  Sleep(1000);
  midiOutShortMsg(hMidiOut, 0x007f3c80); /* m[gIt: C4 (60=3C) */
  midiOutShortMsg(hMidiOut, 0x007f4080); /* m[gIt: E4 (64=40) */
  midiOutShortMsg(hMidiOut, 0x007f4380); /* m[gIt: G4 (67=43) */

  midiOutReset(hMidiOut);
  midiOutClose(hMidiOut);

  return 0;
}
