#include <string.h>
#include <windows.h>
#include <mmsystem.h>

int main(void) {
  HMIDIOUT hMidiOut;
  MIDIHDR header;
  BYTE GMSystemOn[] = {0xf0, 0x7e, 0x7f, 0x09, 0x01, 0xf7};
//  int i;

  midiOutOpen(&hMidiOut, MIDI_MAPPER, 0, 0, 0);

  ZeroMemory(&header, sizeof(MIDIHDR));
  header.lpData = (LPSTR)GMSystemOn;
  header.dwBufferLength = sizeof(GMSystemOn);
  header.dwFlags = 0;

  midiOutPrepareHeader(hMidiOut, &header, sizeof(MIDIHDR));
  midiOutLongMsg(hMidiOut, &header, sizeof(MIDIHDR));
  Sleep(100);
  midiOutUnprepareHeader(hMidiOut, &header, sizeof(MIDIHDR));

/*
  for (i=0; i<128; i++) {
    printf("%d\n", i+1);

    midiOutShortMsg(hMidiOut, 0x000000c0 | (i << 8));
    midiOutShortMsg(hMidiOut, 0x00403c90);
    Sleep(1000);
    midiOutShortMsg(hMidiOut, 0x00003c90);
  }
*/

  midiOutShortMsg(hMidiOut, 0x00002ac0);
  midiOutShortMsg(hMidiOut, 0x00403c90);
  Sleep(1000);
  midiOutShortMsg(hMidiOut, 0x00003c90);

  midiOutShortMsg(hMidiOut, 0x00000ec0);
  midiOutShortMsg(hMidiOut, 0x00403c90);
  Sleep(1000);
  midiOutShortMsg(hMidiOut, 0x00003c90);

  midiOutReset(hMidiOut);
  midiOutClose(hMidiOut);

  return 0;
}
