#include <stdio.h>
#include <windows.h>
#include <mmsystem.h>

int main(void) {
  MIDIOUTCAPS outCaps;
  MMRESULT res;
  UINT num, devid;

  num = midiOutGetNumDevs();
  printf("Number of output devices: %d\n", num);
  for (devid=0; devid<num; devid++) {
    res = midiOutGetDevCaps(devid, &outCaps, sizeof(outCaps));
    if (res != MMSYSERR_NOERROR) { continue; }
    printf("ID=%d: %s\n", devid, outCaps.szPname);
  }

  return 0;
}
