#include <stdio.h>
#include <windows.h>
#include <mmsystem.h>

int main(int argc, char **argv) {
  HMIDIIN hMidiIn;              /* MIDI̓foCX̃nh */
  MMRESULT res;                 /* ߂lێ */
  UINT devid;                   /* foCXID */
  char errmsg[MAXERRORLENGTH];  /* G[bZ[Wi[p */

  if (argc > 1) {
    /* w肳Ăunsigned intƂēǂݍdevidɊi[ */
    sscanf(argv[1], "%u", &devid);
  } else {
    /* w肳ĂȂ0Ƃ */
    devid = 0u;
  }

  /* MIDI̓foCXJ */
  res = midiInOpen(&hMidiIn, devid, (DWORD_PTR)NULL, 0, CALLBACK_NULL);
  if (res != MMSYSERR_NOERROR) {
    /* G[ꍇ͕Wo͂ɃG[bZ[W\ďI */
    printf("Cannot open MIDI input device (ID=%u): ", devid);
    midiInGetErrorText(res, errmsg, sizeof(errmsg));
    printf("%s\n", errmsg);
    return 1;
  }
  printf("Succeeded to open a MIDI input device (ID=%u).\n", devid);

  /* MIDI̓foCX */
  midiInClose(hMidiIn);
  printf("Closed a MIDI input device.\n");

  return 0;
}
