#include <windows.h>
#include <mmsystem.h>

int main(void) {
  HMIDIOUT hMidiOut;
  unsigned int QUAVER = 500;

  midiOutOpen(&hMidiOut, MIDI_MAPPER, 0, 0, 0);

  /* vO`FW: Acoustic Guitar (steel) */
  midiOutShortMsg(hMidiOut, 0x000019c0);

  /* 1ߖ */
  midiOutShortMsg(hMidiOut, 0x00403c90); /* m[gI: C4 */
  midiOutShortMsg(hMidiOut, 0x00402999); /* Closed Hi-Hat */
  Sleep(QUAVER);

  midiOutShortMsg(hMidiOut, 0x00402999); /* Closed Hi-Hat */
  Sleep(QUAVER);
  midiOutShortMsg(hMidiOut, 0x00003c90); /* m[gIt: C4 */

  midiOutShortMsg(hMidiOut, 0x00404090); /* m[gI: E4 */
  midiOutShortMsg(hMidiOut, 0x00402599); /* Acoustic Snare */
  Sleep(QUAVER);

  midiOutShortMsg(hMidiOut, 0x00402999); /* Closed Hi-Hat */
  Sleep(QUAVER);
  midiOutShortMsg(hMidiOut, 0x00004090); /* m[gIt: E4 */

  /* 2ߖ */
  midiOutShortMsg(hMidiOut, 0x00404390); /* m[gI: G4 */
  midiOutShortMsg(hMidiOut, 0x00402999); /* Closed Hi-Hat */
  Sleep(QUAVER);

  midiOutShortMsg(hMidiOut, 0x00402999); /* Closed Hi-Hat */
  Sleep(QUAVER);
  midiOutShortMsg(hMidiOut, 0x00004390); /* m[gIt: G4 */

  midiOutShortMsg(hMidiOut, 0x00404890); /* m[gI: C5 */
  midiOutShortMsg(hMidiOut, 0x00402599); /* Acoustic Snare */
  Sleep(QUAVER);

  midiOutShortMsg(hMidiOut, 0x00402999); /* Closed Hi-Hat */
  Sleep(QUAVER);
  midiOutShortMsg(hMidiOut, 0x00004890); /* m[gIt: C5 */

  midiOutReset(hMidiOut);
  midiOutClose(hMidiOut);

  return 0;
}
